/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

void main ()
{
    // przeksztacenie wektora normalnego gl_Normal do wsprzdnych ukadu obserwatora
    // przy uyciu macierzy gl_NormalMatrix); jest to standardowe przeksztacenie
    // klasycznego potoku OpenGL; otrzymany rezultat jest normalizowany
    vec3 N = normalize (gl_NormalMatrix * gl_Normal);

    // normalizacja wektora kierunku wiata; zakadamy, e mamy wiato
    // kierunkowe, std gl_LightSource[0].position zawiera wektor kierunku wiata
    vec3 L = normalize (vec3 (gl_LightSource[0].position));

    // obliczenie cosinusa kta pomidzy wektorem normalnym a wektorem
    // kierunku wiata; poniewa oba wektory s jednostkowe ich iloczyn
    // skalarny jest rwny poszukiwanemu cosinusowi
    float NdotL = max (dot (N,L),0.0);

    // warto pocztkowa skadowych wiata odbitego
    vec4 specular = vec4 (0.0);

    // obliczenia zwizane ze wiatem odbitym wykonywane s tylko dla owietlonych powierzchni
    if (NdotL > 0.0)
    {
        // normalizacja wektora powkowego i obliczenie cosinusa 
        // kta pomidzy wektorem normalnym a wektorem powkowym
        float NdotH = max (dot (N,normalize (gl_LightSource[0].halfVector.xyz)),0.0);

        // obliczenie wartoci skadowych wiata odbitego
        specular = gl_FrontMaterial.specular * gl_LightSource[0].specular * pow (NdotH,gl_FrontMaterial.shininess);
    }

    // obliczenie wartoci skadowych koloru wierzchoka
    gl_FrontColor = NdotL * gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse +
                    gl_FrontMaterial.ambient * gl_LightSource[0].ambient +
                    gl_FrontMaterial.ambient * gl_LightModel.ambient +
                    specular;

    // standardowe przeksztacenie wierzchokw
    gl_Position = ftransform ();
}
